// 2-3  (    )
//   

#include<stdio.h>
#include<stdlib.h>
#include<memory.h>
#include<conio.h>

#define CHECK_SIZE 10		//   
#define LIST_SIZE 3			//   (     )

#if LIST_SIZE<2 
#error
#endif

struct node_st; struct list_st; union ref_type{node_st *pnode; list_st *plist;}; //  
struct cell_st{ int v; ref_type p;};					//!<  
struct node_st{cell_st arr[3];};				//!<   
struct list_st{int count; int v[LIST_SIZE];};	//!<  
// v   
// p   
// count  

ref_type tree_root;	//!<    
int tree_h;		//!<  

//=====  =====

//!   
node_st* NewNode()
{
	node_st *t=new node_st;
	memset(t,0,sizeof(node_st));
	return t;
}

//!   
list_st* NewList()
{
	list_st *t=new list_st;
	memset(t,0,sizeof(list_st));
	return t;
}

//!  
void FreeNode(node_st *node)
{
	delete node;
}

//!  
void FreeList(list_st *list)
{
	delete list;
}



//!  
void Init()
{
	tree_root.plist=0; tree_h=0; 
}

//=====    =====

//!  
//! \param list   
//! \param sl  ,     
//! \result   
inline list_st* SplitList(list_st *list,int slack)
{
	int i;
	list_st *t=NewList();
	for(i=0; i<LIST_SIZE/2; i++) t->v[i]=list->v[i+(LIST_SIZE+1)/2];
	t->v[i++]=slack; t->count=i;
	list->count=(LIST_SIZE+1)/2;
	return t;
}


//!  
//! \param node   
//! \param sl  ,     
//! \result   
inline node_st* SplitNode(node_st* node,cell_st slack)
{
	node_st *t=NewNode();
	t->arr[0]=node->arr[2];
	t->arr[1]=slack;	
	node->arr[2].p.pnode=0;
	return t;
}



//!    
//! \param list   
//! \param value  
//! \result  ,     
inline list_st* InsertToList(list_st *list,int value)
{
	int i,n;
	int slack;
	for(i=0; i<list->count; i++) {
		if(list->v[i]==value) return 0;
		if(list->v[i]>value) break;
	}
	slack=list->v[LIST_SIZE-1];
	for(n=LIST_SIZE-1; n>i; n--) list->v[n]=list->v[n-1];
	if(i<LIST_SIZE) list->v[i]=value; else slack=value;
	list->count++;
	if(list->count<=LIST_SIZE) return 0;
	return SplitList(list,slack);
}

//!    
//! \param node   
//! \param i      
//! \param ref  
//! \param min   
//! \result !=VOID   ,     
inline node_st* InsertToNode(node_st *node,int i,node_st *ref,int min)
{
	int n;
	cell_st slack_n;
	slack_n=node->arr[2];
	for(n=1; n>i; n--) node->arr[n+1]=node->arr[n];	
	if(i<2) node->arr[i+1].p.pnode=ref,node->arr[i+1].v=min; 
	else slack_n.p.pnode=ref,slack_n.v=min;
	if(!slack_n.p.pnode) return 0;
	return SplitNode(node,slack_n);
}

//!        (   )
//! \param node   
//! \param depth
//! \result  
int GetCount(ref_type node,int depth)
{
	int n;
	if(depth==tree_h) return node.plist->count;
	for(n=0; n<3; n++) if(!node.pnode->arr[n].p.pnode) break;
	return n;
}


//!   
//! \param i1   ( )
//! \param i2   ( )
inline void MergeList(list_st *list1,list_st *list2)
{
	int n,m;
	n=list1->count;
	for(m=0; m<list2->count && n<LIST_SIZE; m++,n++) list1->v[n]=list2->v[m];
	list1->count=n;
	FreeList(list2);
}

//!   
//! \param i1   ( )
//! \param i2   ( )
inline void MergeNode(node_st *node1,node_st *node2)
{
	int n,m;
	for(n=0; n<3; n++) if(!node1->arr[n].p.pnode) break;
	for(m=0; m<3 && n<3;) node1->arr[n++]=node2->arr[m++];
	FreeNode(node2);
}



//!    
//! \param node   
//! \param i   
inline RemoveFromNode(node_st *node,int i)
{
	int n;
	for(n=i; n<2; n++) node->arr[n]=node->arr[n+1];
	node->arr[2].p.pnode=0;

}

//!   
inline void PourNodeL(node_st *node1,node_st *node2)
{
	int n; //,min=nodes[from].arr[0].v;
	if(node1->arr[2].p.pnode) _asm { int 3 }
	for(n=0; n<3; n++) if(!node1->arr[n].p.pnode) break;
	node1->arr[n]=node2->arr[0];
	RemoveFromNode(node2,0);
}

//!   
inline void PourNodeR(node_st *node1,node_st *node2)
{
	int n;
	if(node2->arr[2].p.pnode) _asm { int 3 }
	for(n=2; n; n--) if(node1->arr[n].p.pnode) break;
	InsertToNode(node2,-1,node1->arr[n].p.pnode,node1->arr[n].v);
	node1->arr[n].p.pnode=0;
}

//!   
inline void PourListL(list_st *list1,list_st *list2)
{
	int n;
	list1->v[list1->count++]=list2->v[0];
	for(n=1; n<list2->count; n++) list2->v[n-1]=list2->v[n];
	list2->count--;
}

//!   
inline void PourListR(list_st *list1,list_st *list2)
{
	int n;
	for(n=list2->count;n;n--) list2->v[n]=list2->v[n-1]; 
	list1->count--; list2->count++;
	list2->v[0]=list1->v[list1->count];	
}

//!  , 
//! \param node     
//! \param depth  
void Drop(ref_type node,int depth)
{
	int n;
	if(depth==tree_h) {
		delete node.plist;
		return;
	}
	for(n=0; n<3; n++) if(node.pnode->arr[n].p.pnode) Drop(node.pnode->arr[n].p,depth+1); else break;
	delete node.pnode;
}

//=====     =====

//!  ,  
//! \param node  
//! \param depth 
void Show(ref_type node,int depth,int nn)
{
	int n,m;
	if(!node.pnode) return;
	for(n=0; n<depth*2; n++) putchar(' ');
	if(depth==tree_h) {
		printf("l%d|",nn);
		for(n=0; n<node.plist->count; n++) printf(" %d",node.plist->v[n]);
		putchar('\n');
		return;
	}
	printf("n%d| ",nn);
	if(!node.pnode->arr[0].p.pnode) {printf("empty\n");return;}
	for(m=0; m<3; m++) {
		if(!node.pnode->arr[m].p.pnode) break;
		//if(m) 
			printf("[%d]",node.pnode->arr[m].v);
		printf("%d",m);
	}
	putchar('\n');
	for(n=0; n<3; n++) Show(node.pnode->arr[n].p,depth+1,n);
}

//!  ,  
//! \param node    
//! \param depth 
//! \param value  
//! \result     
node_st* InsertSub(ref_type node,int depth,int value)
{
	static int min1,min2;
	int i; ref_type p;
	if(depth==tree_h) {	
		//     
		p.plist=InsertToList(node.plist,value); 
		min1=node.plist->v[0];
		if(!p.plist) return 0;
		min2=p.plist->v[0];
		goto exit;
	}
	//           (    )
	min1=node.pnode->arr[0].v;
	for(i=0; i<3; i++) {	
		if(!node.pnode->arr[i].p.pnode) break;
		if(value==node.pnode->arr[i].v) return 0;
		if(value<node.pnode->arr[i].v) break;
	}
	if(i) i--;
	p.pnode=InsertSub(node.pnode->arr[i].p,depth+1,value); //   
	node.pnode->arr[i].v=min1;
	min1=node.pnode->arr[0].v;
	if(!p.pnode) return 0;
	//     
	p.pnode=InsertToNode(node.pnode,i,p.pnode,min2); 
	if(!p.pnode) return 0;
	min2=p.pnode->arr[0].v;
exit:
	if(depth) return p.pnode;	//   ,    .
	node_st *t=NewNode(); tree_h++;
	t->arr[0].p=tree_root;
	t->arr[1].p=p;
	t->arr[0].v=min1;
	t->arr[1].v=min2;
	tree_root.pnode=t;
	return 0;
}


//!  ,  
//! \param node 
//! \param depth 
//! \param value 
void RemoveSub(ref_type node,int depth,int value)
{
	static int min;
	int n,i1,i2;
	int count1,count2;	//       
	ref_type ref1,ref2;		//     
	if(depth==tree_h) {	
		//   ,    
		for(n=0; n<node.plist->count; n++) if(node.plist->v[n]==value) break;
		if(n<node.plist->count) {
			for(;n<LIST_SIZE-1; n++) node.plist->v[n]=node.plist->v[n+1];
			node.plist->count--;
		}
		min=node.plist->v[0];
		return;
	}
	//     ,     
	for(i1=0; i1<3; i1++) {	
		if(value<node.pnode->arr[i1].v || !node.pnode->arr[i1].p.pnode) break;
	}
	i1--; if(i1<0) return;
	RemoveSub(node.pnode->arr[i1].p,depth+1,value); //   
	node.pnode->arr[i1].v=min;
	//      (    )
	switch(i1) {
	case 0: i2=1; break;
	case 1: if(!node.pnode->arr[2].p.pnode || GetCount(node.pnode->arr[0].p,depth+1)<GetCount(node.pnode->arr[2].p,depth+1)) i1=0,i2=1; else i1=1,i2=2; break;
	case 2: i1=1; i2=2; break;
	}
	ref1=node.pnode->arr[i1].p;
	ref2=node.pnode->arr[i2].p;
	count1=GetCount(ref1,depth+1);
	count2=GetCount(ref2,depth+1);
	if(depth==tree_h-1) { //   ,      
		if(count1+count2<=LIST_SIZE) { //    
			MergeList(ref1.plist,ref2.plist);
			RemoveFromNode(node.pnode,i2);
#if LIST_SIZE==2
			node.pnode->arr[i1].v=ref1.plist->v[0];
#endif
		} else
			if(abs(count1-count2)>1) { //  
			if(count1>count2) PourListR(ref1.plist,ref2.plist); else PourListL(ref1.plist,ref2.plist);
			node.pnode->arr[i2].v=ref2.plist->v[0];
		}
	} else {
		if(count1+count2<=3) {	//  
			MergeNode(ref1.pnode,ref2.pnode);
			RemoveFromNode(node.pnode,i2);
		}
		if(abs(count1-count2)>1) { //  
			if(count1>count2) PourNodeR(ref1.pnode,ref2.pnode); else PourNodeL(ref1.pnode,ref2.pnode);
			node.pnode->arr[i2].v=ref2.pnode->arr[0].v;
		}
	}
	min=node.pnode->arr[0].v;
}

//=====   (   ) =====

//!  
void Show()
{
	printf("[show]\n");
	if(!tree_root.pnode) printf("empty tree\n"); else Show(tree_root,0,0);
}

//!    
//! \param value  
void Insert(int value)
{
	printf("insert: %d\n",value);
	if(!tree_root.plist) {	//    -   
		tree_root.plist=NewList(); tree_h=0;
		tree_root.plist->count=1;
		tree_root.plist->v[0]=value;
		return;
	}
	InsertSub(tree_root,0,value); 
}

//!   
//! \param value  
void Remove(int value)
{
	printf("remove: %d\n",value);
	RemoveSub(tree_root,0,value);
	while(tree_h>0) { //      ,   
		if(tree_root.pnode->arr[1].p.pnode) break;
		node_st *t=tree_root.pnode; tree_root=tree_root.pnode->arr[0].p;
		FreeNode(t);
		tree_h--;
	}
}

//!  
void DropTree()
{
	Drop(tree_root,0);
	Init();
}


//=====    ======

//     
enum MapCode{
MAPCODE_FREE	=0,	//  
MAPCODE_USE		=1,	//  
MAPCODE_USEOK	=2,	//     
MAPCODE_ERR		=3	//  ,    
};

MapCode map[CHECK_SIZE]; //!<     

//!     ,  
//! \param node  
//! \param depth 
void CheckMap(ref_type node,int depth)
{
	int n,v;
	if(depth==tree_h) {
		for(n=0; n<node.plist->count; n++) { 
			v=node.plist->v[n];
			map[v]=map[v]==MAPCODE_USE?MAPCODE_USEOK:MAPCODE_ERR;
		}
		return;
	}
	for(n=0; n<3; n++) if(node.pnode->arr[n].p.pnode) CheckMap(node.pnode->arr[n].p,depth+1); else break;
}

//!     
//!   
void CheckMap()
{
	int n;
	CheckMap(tree_root,0);
	for(n=0; n<CHECK_SIZE; n++) switch(map[n]) {
	case MAPCODE_FREE: break;
	case MAPCODE_USEOK: map[n]=MAPCODE_USE; break;
	default: _asm { int 3 }
	}
}


//!   ,  
//! \param node  
//! \param seed     (     )
//! \param depth 
//! \result     
int Check(ref_type node,int *seed,int depth)
{
	int n,r,t;
	if(!node.pnode) return -1;
	if(depth==tree_h) {
		for(n=0; n<node.plist->count; n++) {
			if(node.plist->v[n]<0 || node.plist->v[n]>=CHECK_SIZE) _asm { int 3 }
			if(*seed<node.plist->v[n]) *seed=node.plist->v[n]; else _asm { int 3 }
		}
		return node.plist->v[0];
	}
	if(!node.pnode->arr[1].p.pnode) _asm { int 3 }
	r=-1;
	for(n=0; n<3; n++) {
		if(!node.pnode->arr[n].p.pnode) break;
		t=Check(node.pnode->arr[n].p,seed,depth+1);
		if(!n) r=t;
		if(node.pnode->arr[n].v!=t) _asm { int 3 }
	}
	return r;
}


//!   
//!          
//!       
//!          
//!   
void Check()
{
	int value=-99;
	Check(tree_root,&value,0);
}


//=============================================================================




void main()
{
	int n,v;
	Init();
	memset(map,MAPCODE_FREE,sizeof(map));
	for(n=0;;n++) 
	{
		printf("[pass: %d]\n",n);
		v=rand()%CHECK_SIZE; map[v]=MAPCODE_USE;  Insert(v);
		v=rand()%CHECK_SIZE; map[v]=MAPCODE_FREE; Remove(v);
		if(!(n%1000)) {
			Show();
			Check();
			CheckMap();
		}
		if(_kbhit()) break;
	}
	//  
	printf("wipe teee\n");
	DropTree();

	printf("[done]\n");
	getchar();
	getchar();
}






